import express from 'express';
import stoppable from 'stoppable';
type ServerConfig = {
    host: string;
    port: number;
};
export declare class MetricsServer {
    private serverConfig;
    private handler;
    private app;
    private httpServer;
    private isShuttingDown;
    constructor({ serverConfig, handler }: {
        serverConfig: ServerConfig;
        handler: express.Handler;
    });
    start(): Promise<{
        app: express.Application;
        httpServer: stoppable.StoppableServer;
    }>;
    stop(): Promise<void>;
    shutdown(): Promise<void>;
}
export {};
