"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerEvents = exports.OnEvent = void 0;
const events = [];
function OnEvent(Event) {
    return function (target, methodName) {
        events.push({
            Event: Event,
            target: target.constructor,
            methodName
        });
    };
}
exports.OnEvent = OnEvent;
function registerEvents(app, DomainEvents) {
    for (const eventSpec of events) {
        DomainEvents.subscribe(eventSpec.Event, async function (event) {
            // We have to cast to `any` here because we don't know the type - but we do know that it should have the `methodName` method
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            const service = await app.resolve(eventSpec.target);
            await service[eventSpec.methodName](event);
        });
    }
}
exports.registerEvents = registerEvents;
//# sourceMappingURL=handle-event.decorator.js.map