/**
 * Entity
 *
 * Represents a "Business Object" in the system
 *
 *  - As much business logic as possible should be here
 *  - Its interface should describe what it is and what it can do/you can do to it.
 *  - Handles the creation of events related to the entity
 */
import { Entity } from '../../common/entity.base';
type GreetingData = {
    greeting: string;
};
export declare class Greeting extends Entity<GreetingData> {
    get greeting(): string;
    set greeting(greeting: string);
    greet(recipient: string): string;
}
export {};
