"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Greeting = void 0;
/**
 * Entity
 *
 * Represents a "Business Object" in the system
 *
 *  - As much business logic as possible should be here
 *  - Its interface should describe what it is and what it can do/you can do to it.
 *  - Handles the creation of events related to the entity
 */
const entity_base_1 = require("../../common/entity.base");
const example_event_1 = require("./example.event");
class Greeting extends entity_base_1.Entity {
    get greeting() {
        return this.attr.greeting;
    }
    set greeting(greeting) {
        this.set('greeting', greeting);
    }
    greet(recipient) {
        let message;
        if (recipient.trim() === 'world') {
            message = 'Hello, world!';
        }
        else {
            message = `${this.greeting}, ${recipient.trim()}.`;
        }
        this.addEvent(example_event_1.ExampleEvent.create({
            message
        }));
        return message;
    }
}
exports.Greeting = Greeting;
//# sourceMappingURL=example.entity.js.map