"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const example_entity_1 = require("./example.entity");
describe('ExampleEntity (Greeting)', function () {
    it('Can greet someone', function () {
        const entity = new example_entity_1.Greeting({
            greeting: 'Bonjour'
        });
        const msg = entity.greet('Margot');
        assert_1.default.equal(msg, 'Bonjour, Margot.');
    });
    it('Has a custom greeting for the recipient "world"', function () {
        const entity = new example_entity_1.Greeting({
            greeting: 'Bonjour'
        });
        const msg = entity.greet('world');
        assert_1.default.equal(msg, 'Hello, world!');
    });
    it('Can have its greeting updated', function () {
        const entity = new example_entity_1.Greeting({
            greeting: 'Bonjour'
        });
        entity.greeting = 'Evening';
        const msg = entity.greet('Guvner');
        assert_1.default.equal(msg, 'Evening, Guvner.');
    });
});
//# sourceMappingURL=example.entity.test.js.map