"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const sinon_1 = __importDefault(require("sinon"));
const example_service_1 = require("./example.service");
const example_entity_1 = require("./example.entity");
const assert_1 = __importDefault(require("assert"));
describe('ExampleService', function () {
    it('Can greet a recipient and save the greeting', async function () {
        const recipient = 'Mr Anderson';
        const entity = new example_entity_1.Greeting({ greeting: 'Testing' });
        const repository = {
            getOne: sinon_1.default.stub().resolves(entity),
            save: sinon_1.default.stub()
        };
        const service = new example_service_1.ExampleService(repository);
        const result = await service.greet(recipient);
        assert_1.default.equal(result, entity.greet(recipient));
        (0, assert_1.default)(repository.save.calledWithExactly(entity));
    });
});
//# sourceMappingURL=example.service.test.js.map