"use strict";
/**
 * Controller
 *
 * These classes are responsible for wiring HTTP Requests to the Service layer.
 * They do not contain business logic.
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExampleController = void 0;
const common_1 = require("@nestjs/common");
const permissions_decorator_1 = require("../../../common/decorators/permissions.decorator");
const example_service_1 = require("../../../core/example/example.service");
const location_header_interceptor_1 = require("../../../nestjs/interceptors/location-header.interceptor");
const admin_api_authentication_guard_1 = require("../../../nestjs/guards/admin-api-authentication.guard");
const permissions_guard_1 = require("../../../nestjs/guards/permissions.guard");
let ExampleController = class ExampleController {
    service;
    constructor(service) {
        this.service = service;
    }
    async read(recipient) {
        const greeting = await this.service.greet(recipient);
        return greeting;
    }
};
exports.ExampleController = ExampleController;
__decorate([
    (0, permissions_decorator_1.Roles)([
        'Admin',
        'Author',
        'Contributor',
        'Editor',
        'Owner',
        'Admin Integration'
    ]),
    (0, common_1.Get)(':recipient'),
    __param(0, (0, common_1.Param)('recipient')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], ExampleController.prototype, "read", null);
exports.ExampleController = ExampleController = __decorate([
    (0, common_1.UseInterceptors)(location_header_interceptor_1.LocationHeaderInterceptor),
    (0, common_1.UseGuards)(admin_api_authentication_guard_1.AdminAPIAuthentication, permissions_guard_1.PermissionsGuard),
    (0, common_1.Controller)('greetings'),
    __metadata("design:paramtypes", [example_service_1.ExampleService])
], ExampleController);
//# sourceMappingURL=example.controller.js.map