import { CanActivate, ExecutionContext } from '@nestjs/common';
import { Request, Response } from 'express';
import { Actor } from '../../common/types/actor.type';
declare global {
    namespace Express {
        interface Request {
            actor?: Actor;
        }
    }
}
interface SessionService {
    getUserForSession(req: Request, res: Response): Promise<any>;
}
interface AuthenticationService {
    authenticateWithToken(url: string, token: string, ignoreMaxAge: boolean): Promise<any>;
}
export declare class AdminAPIAuthentication implements CanActivate {
    private sessionService;
    private authService;
    constructor(sessionService: SessionService, authService: AuthenticationService);
    canActivate(context: ExecutionContext): Promise<boolean>;
    private setUserActor;
}
export {};
